package choco.bool;

import choco.AbstractConstraint;
import choco.Constraint;
import choco.ContradictionException;
import choco.Var;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File choco.bool.ConstantConstraint.java, last modified by flaburthe 13 avr. 2004 10:28:39 */

public class ConstantConstraint extends AbstractConstraint {
  private boolean satisfied;

  public ConstantConstraint(boolean value) {
    satisfied = value;
  }

  public int getNbVars() {
    return 0;
  }

  public Var getVar(int i) {
    return null;
  }

  public boolean isCompletelyInstantiated() {
    return true;
  }

  public boolean isSatisfied() {
    return satisfied;
  }

  public void propagate() throws ContradictionException {
    if (!satisfied) {
      fail();
    }
  }

  public boolean isConsistent() {
    return satisfied;
  }

  public int assignIndices(AbstractCompositeConstraint root, int i) {
    return i;
  }

  public void setConstraintIndex(int i, int idx) {
    throw new UnsupportedOperationException();
  }

  public int getConstraintIdx(int idx) {
    throw new UnsupportedOperationException();
  }

  public final boolean isEquivalentTo(Constraint compareTo) {
    if (compareTo instanceof ConstantConstraint) {
      ConstantConstraint c = (ConstantConstraint) compareTo;
      return (this.satisfied == c.satisfied);
    } else {
      return false;
    }
  }

}
