// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File choco.search.search.StaticVarOrder.java, last modified by Francois 10 nov. 2003 10:23:19 */
package choco.integer.search;

import choco.integer.var.IntDomainVar;

/**
 * A variable selector selecting the first non instantiated variable according to a given static order
 */
public class StaticVarOrder extends AbstractIntVarSelector {
  /**
   * the sequence of variables that need be instantiated
   */
  protected choco.integer.var.IntDomainVar[] vars;

  public choco.integer.var.IntDomainVar selectIntVar() {
    for (int i = 0; i < vars.length; i++) {
      if (!vars[i].isInstantiated()) {
        return vars[i];
      }
    }
    return null;
  }
}
