// *********************************************
// *                   J-CHOCO                 *
// *   Copyright (c) F. Laburthe, 1999-2003    *
// *********************************************
// * Event-base contraint programming Engine   *
// *********************************************

// CVS Information
// File:               $RCSfile: IntVarEventListener.java,v $
// Version:            $Revision: 1.1.1.1 $
// Last Modification:  $Date: 2004/05/11 13:51:47 $
// Last Contributor:   $Author: laburthe $

package choco.integer.var;

import choco.ContradictionException;
import choco.prop.VarEventListener;


/**
 * An interface for all the search variable listeners.
 */
public interface IntVarEventListener extends VarEventListener {

  /**
   * Default propagation on improved lower bound: propagation on domain revision.
   */

  public void awakeOnInf(int varIdx) throws ContradictionException;


  /**
   * Default propagation on improved upper bound: propagation on domain revision.
   */

  public void awakeOnSup(int varIdx) throws ContradictionException;


  /**
   * Default propagation on instantiation: full constraint re-propagation.
   */

  public void awakeOnInst(int varIdx) throws ContradictionException;


  /**
   * Default propagation on one value removal: propagation on domain revision.
   */

  public void awakeOnRem(int varIdx, int val) throws ContradictionException;
}
