//     ___  ___         PaLM library for Choco system
//    /__ \/ __\        (c) 2001 - 2004 -- Narendra Jussien
//   ____\ |/_____
//  /_____\/_____ \     Explanation based constraint programming tool
// |/   (_)(_)   \|
//       \ /            Version 0.1
//       \ /            January 2004
//       \ /
// ______\_/_______     Contibutors: Franois Laburthe, Hadrien Cambazard, Guillaume Rochart...

package choco.palm.integer.explain;

import choco.palm.explain.GenericExplanation;
import choco.palm.PalmProblem;
import choco.palm.integer.PalmIntVar;

import java.util.Set;
import java.util.BitSet;

import choco.Problem;
import choco.Constraint;

public class RemovalExplanation extends choco.palm.explain.GenericExplanation implements IRemovalExplanation {
  protected int value;
  protected PalmIntVar variable;

  public RemovalExplanation(Problem pb, BitSet explanation, int value, PalmIntVar variable) {
    super(pb);
    this.value = value;
    this.explanation = explanation;
    this.variable = variable;
  }

  public String toString() {
    return this.variable + " != " + this.value + " because " + super.toString();
  }

  public void postUndoRemoval(Constraint removed) {
    this.removeDependencies(removed);
    this.variable.restoreVal(this.value);
    this.variable.resetExplanationOnVal(value);
  }
}
