//     ___  ___         PaLM library for Choco system
//    /__ \/ __\        (c) 2001 - 2004 -- Narendra Jussien
//   ____\ |/_____
//  /_____\/_____ \     Explanation based constraint programming tool
// |/   (_)(_)   \|
//       \ /            Version 0.1
//       \ /            January 2004
//       \ /
// ______\_/_______     Contibutors: Franois Laburthe, Hadrien Cambazard, Guillaume Rochart...

package choco.palm.prop;

import choco.Constraint;
import choco.integer.IntVar;
import choco.palm.integer.PalmIntVarListener;
import choco.palm.integer.PalmIntVar;
import choco.util.IntIterator;

/**
 * Created by IntelliJ IDEA.
 * User: rochart
 * Date: Jan 14, 2004
 * Time: 11:25:01 AM
 * To change this template use Options | File Templates.
 */
public final class StructureMaintainer {
  public static void updateDataStructures(IntVar var, int select, int newValue, int oldValue) {
    updateDataStructuresOnVariable(var, select, newValue, oldValue);
    updateDataStructuresOnConstraints(var, select, newValue, oldValue);
  }

  public static void updateDataStructuresOnVariable(IntVar var, int select, int newValue, int oldValue) {
    // A redefinir si necessaire
  }

  public static void updateDataStructuresOnConstraints(IntVar var, int select, int newValue, int oldValue) {
    Constraint[] constraints = var.getConstraints();
    Integer[] indices = var.getVarIndices();

    for (IntIterator cit = ((PalmIntVar) var).getEvent().getAllListenersButIterator(-1); cit.hasNext();) {
      int index = cit.next();
      ((PalmIntVarListener) constraints[index]).updateDataStructuresOnConstraint(indices[index].intValue(), select, newValue, oldValue);
    }
  }

  public static void updateDataStructuresOnRestore(IntVar var, int select, int newValue, int oldValue) {
    updateDataStructuresOnRestoreVariable(var, select, newValue, oldValue);
    updateDataStructuresOnRestoreConstraints(var, select, newValue, oldValue);
  }

  public static void updateDataStructuresOnRestoreVariable(IntVar var, int select, int newValue, int oldValue) {
    // A redefinir si necessaire
  }

  public static void updateDataStructuresOnRestoreConstraints(IntVar var, int select, int newValue, int oldValue) {
//AbstractVar v = getModifiedVar();
    Constraint[] constraints = var.getConstraints();
    Integer[] indices = var.getVarIndices();

    for (IntIterator cit = ((PalmIntVar) var).getEvent().getAllListenersButIterator(-1); cit.hasNext();) {
      int index = cit.next();
      ((PalmIntVarListener) constraints[index]).updateDataStructuresOnRestoreConstraint(indices[index].intValue(), select, newValue, oldValue);
    }
  }
}
