//     ___  ___         PaLM library for Choco system
//    /__ \/ __\        (c) 2001 - 2004 -- Narendra Jussien
//   ____\ |/_____
//  /_____\/_____ \     Explanation based constraint programming tool
// |/   (_)(_)   \|
//       \ /            Version 0.1
//       \ /            January 2004
//       \ /
// ______\_/_______     Contibutors: Franois Laburthe, Hadrien Cambazard, Guillaume Rochart...

package choco.palm.real;

import choco.ContradictionException;
import choco.real.constraint.RealListener;
import choco.palm.PalmVarListener;


public interface PalmRealVarListener extends PalmVarListener, RealListener{
  /**
   * Handles an inf bound restoration on the constraint <code>idx</code>
   * @param idx Variable involved.
   * @throws choco.ContradictionException
   */

  public void awakeOnRestoreInf(int idx) throws ContradictionException;


  /**
   * Handles a sup bound restoration on the constraint <code>idx</code>
   * @param idx Variable involved.
   * @throws ContradictionException
   */

  public void awakeOnRestoreSup(int idx) throws ContradictionException;
}
