//     ___  ___         PaLM library for Choco system
//    /__ \/ __\        (c) 2001 - 2004 -- Narendra Jussien
//   ____\ |/_____
//  /_____\/_____ \     Explanation based constraint programming tool
// |/   (_)(_)   \|
//       \ /            Version 0.1
//       \ /            January 2004
//       \ /
// ______\_/_______     Contibutors: Franois Laburthe, Hadrien Cambazard, Guillaume Rochart...

package choco.palm.search;


import choco.palm.explain.PalmConstraintPlugin;
import choco.palm.PalmProblem;


import java.util.*;

import choco.Constraint;
import choco.ContradictionException;

public class PalmLearn extends PalmAbstractSolverTool {
  public void learnFromContradiction(choco.palm.explain.Explanation expl) throws ContradictionException {
  }

  public void learnFromRemoval(Constraint constraint) {
  }

  public boolean checkAcceptable(List constraints) {
    return true;
  }

  public boolean checkAcceptableRelaxation(Constraint constraint) {
    return true;
  }

  public ArrayList sortConstraintToUndo(choco.palm.explain.Explanation expl) {
    PalmProblem pb =  ((PalmProblem) this.getManager().getProblem());
    ArrayList list = new ArrayList();
    BitSet bset = expl.getBitSet();    // iterate on the bitset and avoid HashSet !!!!!!
    for (int i = bset.nextSetBit(0); i >= 0; i = bset.nextSetBit(i + 1)) {
        Constraint ct = pb.getConstraintNb(i);
        if (((PalmConstraintPlugin)(ct).getPlugIn()).getWeight() == 0)
                list.add(ct);
    }
    // We assume that all decision constraints use the same comparator defined by the user
    if (!list.isEmpty()) {
        Comparator Comp = ((PalmConstraintPlugin)((Constraint)list.get(0)).getPlugIn()).getSearchInfo().getComparator();
        Collections.sort(list,Comp);
    }
    return list;
  }

}
