package choco.palm.search.pathrepair;

import choco.palm.search.PalmAssignVar;
import choco.palm.PalmProblem;
import choco.palm.explain.Explanation;
import choco.palm.prop.PalmEngine;
import choco.palm.integer.PalmIntVar;
import choco.palm.integer.PalmIntDomain;
import choco.integer.IntVar;

import java.util.List;
import java.util.LinkedList;
import java.util.logging.Logger;

/**
 * Created by IntelliJ IDEA.
 * User: Administrateur
 * Date: 15 janv. 2004
 * Time: 17:18:37
 * To change this template use Options | File Templates.
 */
public class PathRepairAssignVar extends PalmAssignVar{

   protected PalmIntVar variable;
   protected int value;

   public Object selectBranchingObject() {
    IntVar var = (IntVar) ((PalmProblem)this.extender.getManager().getProblem()).getMinDomVar();
    if (var != null) {
          this.variable = (PalmIntVar) var;
          this.value = var.getInf();
    }
    return var;
   }

  /**
   *  return the next possible decision (variable assignement) on the variable
   * @param branchingItem
   * @param previousBranch
   */

  public Object getNextBranch(Object branchingItem, Object previousBranch) {
    List list = new LinkedList();
    list.add(variable.getDecisionConstraint(value));
    value ++;
    while (!variable.getDomain().contains(value) & value < variable.getSup())
      value ++;
    return list;
  }

 /**
  *  Check if a decision is valid (according to the learner)
  */
  public boolean checkAcceptable(List csts) {
     return true;
  }


  /**
   *  check if the variable has been emptied
   */

  public void learnFromRejection() {
    if (value == variable.getSup()) {  // no more available value
        Explanation expl = ((PalmProblem)this.extender.getManager().getProblem()).makeExplanation();;
        variable.self_explain(PalmIntDomain.DOM,expl);
        ((PalmEngine)this.extender.getManager().getProblem().getPropagationEngine()).raisePalmFakeContradiction(expl);
    }
  }

}
