package choco.real;

import choco.ContradictionException;
import choco.Entity;

/**
 * An interface for real intervals.
 */
public interface RealInterval {
  /**
   * @return the lower bound.
   */
  public double getInf();

  /**
   * @return the upper bound.
   */
  public double getSup();

  /**
   * Modifies the bounds for intersecting with the specified interval.
   * @param interval
   * @throws ContradictionException
   */
  public void intersect(RealInterval interval) throws ContradictionException;

  /**
   * Modifies the bounds for intersecting with the specified interval.
   * @param interval
   * @param index of the constraint responsible to this withdraw
   * @throws ContradictionException
   */
  public void intersect(RealInterval interval, int index) throws ContradictionException;
}
