package choco.real.exp;

import choco.real.RealInterval;
import choco.real.RealExp;
import choco.real.RealMath;
import choco.ContradictionException;
import choco.Problem;

/**
 * An expression modelling a substraction.
 */
public class RealPlus extends AbstractRealBinTerm {
  public RealPlus(Problem pb, RealExp exp1, RealExp exp2) {
    super(pb, exp1, exp2);
  }

  public void tighten() {
    RealInterval res = RealMath.add(exp1, exp2);
    inf.set(res.getInf());
    sup.set(res.getSup());
  }

  public void project() throws ContradictionException {
    exp1.intersect(RealMath.sub(this, exp2));
    exp2.intersect(RealMath.sub(this, exp1));
  }
}
