package choco.search;

import choco.branch.IntBranching;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File choco.search.IntBranchingTrace.java, last modified by guillaume 09 may 2004 */

/**
 * A class for keeping a trace of the search algorithm, through an IntBranching
 * (storing the current branching object, as well as the label of the current branch)
 */
public class IntBranchingTrace {
  private IntBranching branching;
  private Object branchingObject;
  private int branchIndex;

  public IntBranchingTrace() {
  }
  public IntBranchingTrace(IntBranching ibranching) {
    branching = ibranching;
  }
  
  public void setBranching(IntBranching ibranching) {
    branching = ibranching;
  }
  public void setBranchingObject(Object branchingObj) {
    branchingObject = branchingObj;
  }
  public void setBranchIndex(int bIdx) {
    branchIndex = bIdx;
  }
  public IntBranching getBranching() {
    return branching;
  }
  public Object getBranchingObject( ) {
    return branchingObject;
  }
  public int getBranchIndex() {
    return branchIndex;
  }

  public void clear() {
    branching = null;
    branchingObject = null;
    branchIndex = -999;
  }

}
