package choco.set.search;

import choco.search.AbstractBinIntBranching;
import choco.search.AbstractGlobalSearchSolver;
import choco.search.AbstractIntBranching;
import choco.ContradictionException;
import choco.Problem;
import choco.set.SetVar;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

public abstract class AbstractSetBranching extends AbstractIntBranching {

  public int getNextBranch(Object x, int i) {

    return 0;
  }

  public boolean finishedBranching(Object x, int i) {

    return false;
  }

  public void goDownBranch(Object x, int i, int numBranch) throws ContradictionException {
    super.goDownBranch(x,i);
    if (numBranch == 1) {
      SetVar y = (SetVar) x;
      //System.out.println("addToKer[" + y + "," + i + "]");
      y.setValIn(i);
      manager.problem.propagate();
    } else if (numBranch == 2) {
      SetVar y = (SetVar) x;
      //System.out.println("remFromEnv[" + y + "," + i + "]");
      y.setValOut(i);
      manager.problem.propagate();
    }
  }

  public void goUpBranch(Object x, int i, int numBranch) throws ContradictionException {
    super.goUpBranch(x,i);

  }
  public boolean branchOn(Object x, int n) throws ContradictionException {
    AbstractGlobalSearchSolver algo = manager;
    Problem pb = algo.problem;
    boolean nodeSuccess = false;
    boolean nodeFinished = false;
    int i = getFirstBranch(x);
    int numBranch = 1;
    algo.newTreeNode();
    try {
      do {
        boolean branchSuccess = false;
        try {
          pb.getPropagationEngine().checkCleanState();
          pb.getEnvironment().worldPush();
          goDownBranch(x, i, numBranch);
          if (explore(n + 1)) {
            branchSuccess = true;
          }
        } catch (ContradictionException e) {
          ;
        }
        if (!branchSuccess) {
          pb.getEnvironment().worldPop();
        }
        algo.endTreeNode();
        algo.postDynamicCut();
        goUpBranch(x, i, numBranch);
        if (branchSuccess) {
          nodeSuccess = true;
        }
        if (numBranch == 1) {
          numBranch = 2;
        } else {
          nodeFinished = true;
        }
      } while (!nodeSuccess && !nodeFinished);
    } catch (ContradictionException e) {
      nodeSuccess = false;
    }
    return nodeSuccess;
  }

}
