package choco.set.search;

import choco.search.AbstractBinIntBranching;
import choco.ContradictionException;
import choco.set.SetVar;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

public class AssignSetVar extends AbstractSetBranching {

  SetVarSelector varselector;
  SetValSelector valselector;

  public AssignSetVar(SetVarSelector varselect, SetValSelector valselect) {
    varselector = varselect;
    valselector = valselect;
  }

  public Object selectBranchingObject() {
    return varselector.selectSetVar();
  }

  public int getFirstBranch(Object x) {
    return valselector.getBestVal((SetVar) x);
  }

}
