package chocosamples;

import choco.Problem;
import choco.ContradictionException;
import choco.integer.IntVar;

import java.util.logging.Logger;

// **************************************************
// *                   J-CHOCO                      *
// *   Copyright (C) F. Laburthe, 1999-2003         *
// **************************************************
// *  an open-source Constraint Programming Kernel  *
// *     for Research and Education                 *
// **************************************************

/* File chocosamples.Zebra.java, last modified by flaburthe 19 janv. 2004 14:56:34 */

public class Zebra {

  private static Logger logger = Logger.getLogger("choco.samples.zebra");
   private static  Problem pb;
   private static IntVar green, blue, yellow, ivory, red;
   private static  IntVar diplomat, painter, sculptor, doctor, violinist;
   private static  IntVar norwegian, english, japanese, spaniard, italian;
   private static  IntVar wine, milk, coffee, water, tea;
   private static IntVar fox, snail, horse, dog, zebra;
   private static IntVar[] colors, trades, nationalities, drinks, pets;
   private static IntVar[][] arrays;

  public static void main(String args[]) {
     logger.fine("Zebra Testing...");
     pb = new Problem();
     green = pb.makeEnumIntVar("green",1,5);
     blue = pb.makeEnumIntVar("blue",1,5);
     yellow = pb.makeEnumIntVar("yellow",1,5);
     ivory = pb.makeEnumIntVar("ivory",1,5);
     red = pb.makeEnumIntVar("red",1,5);
     diplomat = pb.makeEnumIntVar("diplomat",1,5);
     painter = pb.makeEnumIntVar("painter",1,5);
     sculptor = pb.makeEnumIntVar("sculptor",1,5);
     doctor = pb.makeEnumIntVar("doctor",1,5);
     violinist = pb.makeEnumIntVar("violinist",1,5);
     norwegian = pb.makeEnumIntVar("norwegian",1,5);
     english = pb.makeEnumIntVar("english",1,5);
     japanese = pb.makeEnumIntVar("japanese",1,5);
     spaniard = pb.makeEnumIntVar("spaniard",1,5);
     italian = pb.makeEnumIntVar("italian",1,5);
     wine = pb.makeEnumIntVar("wine",1,5);
     milk = pb.makeEnumIntVar("milk",1,5);
     coffee = pb.makeEnumIntVar("coffee",1,5);
     water = pb.makeEnumIntVar("water",1,5);
     tea = pb.makeEnumIntVar("tea",1,5);
     fox = pb.makeEnumIntVar("fox",1,5);
     snail = pb.makeEnumIntVar("snail",1,5);
     horse = pb.makeEnumIntVar("horse",1,5);
     dog = pb.makeEnumIntVar("dog",1,5);
     zebra = pb.makeEnumIntVar("zebra",1,5);
     colors = new IntVar[]{green, blue, yellow, ivory, red};
     trades = new IntVar[]{diplomat, painter, sculptor, doctor, violinist};
     nationalities = new IntVar[]{norwegian, english, japanese, spaniard, italian};
     drinks = new IntVar[]{wine, milk, coffee, water, tea};
     pets = new IntVar[]{fox, snail, horse, dog, zebra};
     arrays = new IntVar[][]{colors, trades, nationalities, drinks, pets};

     for (int a = 0; a < 5; a++) {
       for (int i = 0; i < 4; i++) {
         for (int j = i + 1; j < 5; j++) {
           pb.post( pb.neq(arrays[a][i], arrays[a][j]));
         }
       }
     }
     // help for incomplete alldiff on colors
     pb.post( pb.eq(yellow, 1));
     //
     // help for incomplete alldiff on colors
     pb.post( pb.eq(water, 1));
     //

    pb.post( pb.eq(english, red));
     pb.post( pb.eq(spaniard, dog));
     pb.post( pb.eq(coffee, green));
     pb.post( pb.eq(italian, tea));
     pb.post( pb.eq(sculptor, snail));
     pb.post( pb.eq(diplomat, yellow));
     pb.post( pb.eq(green, pb.plus(ivory, 1)));
     pb.post( pb.eq(milk, 3));
     pb.post( pb.eq(norwegian, 1));
     // pb.post(((doctor - fox == 1) or (doctor - fox == -1)));
     pb.post( pb.eq(pb.minus(doctor, fox), 1));
     pb.post( pb.eq(violinist, wine));
     pb.post( pb.eq(japanese, painter));
     //pb.post(((diplomat - horse == 1) or (diplomat - horse == -1)));
     pb.post(pb.eq(pb.minus(diplomat, horse), -1));
     //pb.post(((norwegian - blue == 1) or (norwegian - blue == -1)));
     pb.post(pb.eq(pb.minus(norwegian, blue), -1));
     try {
       pb.propagate();
       fox.setVal(1);
       pb.propagate();
       italian.setVal(2);
       pb.propagate();
       english.setVal(3);
       pb.propagate();
  //     tea.setVal(2);
       pb.propagate();
     } catch (ContradictionException e) {
     }

    System.out.println(pb.pretty());
    /*for (int a = 0; a < 5; a++) {
      for (int i = 0; i < 5; i++) {
        System.out.println(arrays[a][i].toString() + ": " + arrays[a][i].getDomain().toString());
      }
    } */

  }
}
